precision mediump float;

uniform sampler2D texFluid;
uniform vec2 uTexelSize;

varying vec2 varyTexCoord;

void main()
{
	vec3 dirLight = vec3(0.707, 0.707, 0.0);
	
	vec3 L = texture2D(texFluid, varyTexCoord + vec2(-uTexelSize.x, 0.0)).rgb;
	vec3 R = texture2D(texFluid, varyTexCoord + vec2(uTexelSize.x, 0.0)).rgb;
	vec3 T = texture2D(texFluid, varyTexCoord + vec2(0.0, -uTexelSize.y)).rgb;
	vec3 B = texture2D(texFluid, varyTexCoord + vec2(0.0, uTexelSize.y)).rgb;
	vec3 C = texture2D(texFluid, varyTexCoord).rgb;
	
	float aggrColorL = L.r + L.g + L.b;
	float aggrColorR = R.r + R.g + R.b;
	float aggrColorT = T.r + T.g + T.b;
	float aggrColorB = B.r + B.g + B.b;
	float aggrColorC = C.r + C.g + C.b;
	vec3 grad = normalize(vec3(aggrColorR - aggrColorL, aggrColorT - aggrColorB, 0.01));
	//float lap = 4 * aggrColorC - (aggrColorL + aggrColorR + aggrColorT + aggrColorB);
	//lap = max(abs(2 * aggrColorC - (aggrColorL + aggrColorR)), abs(2 * aggrColorC - (aggrColorT + aggrColorB)));
	
	float specAtten = aggrColorC < min(aggrColorL, min(aggrColorR, min(aggrColorT, aggrColorB))) ? 0.0 : 1.0;
	specAtten *= aggrColorC > max(aggrColorL, max(aggrColorR, max(aggrColorT, aggrColorB))) ? 0.0 : 1.0;
	
	float colorLT = 0.5 * (aggrColorL + aggrColorT);
	float colorRT = 0.5 * (aggrColorR + aggrColorT);
	float colorLB = 0.5 * (aggrColorL + aggrColorB);
	float colorRB = 0.5 * (aggrColorR + aggrColorB);
	
	specAtten *= aggrColorC < min(colorLT, min(colorRT, min(colorLB, colorRB))) ? 0.0 : 1.0;
	specAtten *= aggrColorC > max(colorLT, max(colorRT, max(colorLB, colorRB))) ? 0.0 : 1.0;
	
	float light = dot(grad, dirLight);
	
	gl_FragColor = vec4(light * 0.5 + 0.5, specAtten, 0.0, 0.0);
	//gl_FragColor = vec4(grad * 0.5 + vec3(0.5), 0.0);
}